------------------------- MODULE counterexample -------------------------

EXTENDS MC_n4_f2

(* Initial state *)

State1 ==
/\ Proposer = 0 :> "f4" @@ 1 :> "c2" @@ 2 :> "c1"

(* Transition 0 to State2 *)

State2 ==
/\ Proposer = 0 :> "f4" @@ 1 :> "c2" @@ 2 :> "c1"
/\ decision = "c1" :> "None" @@ "c2" :> "None"
/\ evidence = {}
/\ lockedRound = "c1" :> -1 @@ "c2" :> -1
/\ lockedValue = "c1" :> "None" @@ "c2" :> "None"
/\ msgsPrecommit
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"] }
/\ msgsPrevote
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PREVOTE"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PREVOTE"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PREVOTE"] }
/\ msgsPropose
  = 0
      :> { [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 1
      :> { [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 2
      :> { [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
/\ round = "c1" :> 0 @@ "c2" :> 0
/\ step = "c1" :> "PROPOSE" @@ "c2" :> "PROPOSE"
/\ validRound = "c1" :> -1 @@ "c2" :> -1
/\ validValue = "c1" :> "None" @@ "c2" :> "None"

(* Transition 1 to State3 *)

State3 ==
/\ Proposer = 0 :> "f4" @@ 1 :> "c2" @@ 2 :> "c1"
/\ decision = "c1" :> "None" @@ "c2" :> "None"
/\ evidence
  = {[proposal |-> "v0",
    round |-> 0,
    src |-> "f4",
    type |-> "PROPOSAL",
    validRound |-> -1]}
/\ lockedRound = "c1" :> -1 @@ "c2" :> -1
/\ lockedValue = "c1" :> "None" @@ "c2" :> "None"
/\ msgsPrecommit
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"] }
/\ msgsPrevote
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PREVOTE"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PREVOTE"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PREVOTE"] }
/\ msgsPropose
  = 0
      :> { [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 1
      :> { [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 2
      :> { [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
/\ round = "c1" :> 0 @@ "c2" :> 0
/\ step = "c1" :> "PREVOTE" @@ "c2" :> "PROPOSE"
/\ validRound = "c1" :> -1 @@ "c2" :> -1
/\ validValue = "c1" :> "None" @@ "c2" :> "None"

(* Transition 5 to State4 *)

State4 ==
/\ Proposer = 0 :> "f4" @@ 1 :> "c2" @@ 2 :> "c1"
/\ decision = "c1" :> "None" @@ "c2" :> "None"
/\ evidence
  = { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PREVOTE"],
    [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
    [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
    [proposal |-> "v0",
      round |-> 0,
      src |-> "f4",
      type |-> "PROPOSAL",
      validRound |-> 0] }
/\ lockedRound = "c1" :> 0 @@ "c2" :> -1
/\ lockedValue = "c1" :> "v0" @@ "c2" :> "None"
/\ msgsPrecommit
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"] }
/\ msgsPrevote
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PREVOTE"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PREVOTE"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PREVOTE"] }
/\ msgsPropose
  = 0
      :> { [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 1
      :> { [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 2
      :> { [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
/\ round = "c1" :> 0 @@ "c2" :> 0
/\ step = "c1" :> "PRECOMMIT" @@ "c2" :> "PROPOSE"
/\ validRound = "c1" :> 0 @@ "c2" :> -1
/\ validValue = "c1" :> "v0" @@ "c2" :> "None"

(* Transition 2 to State5 *)

State5 ==
/\ Proposer = 0 :> "f4" @@ 1 :> "c2" @@ 2 :> "c1"
/\ decision = "c1" :> "None" @@ "c2" :> "None"
/\ evidence
  = {[proposal |-> "v1",
    round |-> 0,
    src |-> "f4",
    type |-> "PROPOSAL",
    validRound |-> -1]}
/\ lockedRound = "c1" :> 0 @@ "c2" :> -1
/\ lockedValue = "c1" :> "v0" @@ "c2" :> "None"
/\ msgsPrecommit
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"] }
/\ msgsPrevote
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "c2", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PREVOTE"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PREVOTE"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PREVOTE"] }
/\ msgsPropose
  = 0
      :> { [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 1
      :> { [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 2
      :> { [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
/\ round = "c1" :> 0 @@ "c2" :> 0
/\ step = "c1" :> "PRECOMMIT" @@ "c2" :> "PREVOTE"
/\ validRound = "c1" :> 0 @@ "c2" :> -1
/\ validValue = "c1" :> "v0" @@ "c2" :> "None"

(* Transition 7 to State6 *)

State6 ==
/\ Proposer = 0 :> "f4" @@ 1 :> "c2" @@ 2 :> "c1"
/\ decision = "c1" :> "None" @@ "c2" :> "None"
/\ evidence
  = { [id |-> "v1", round |-> 0, src |-> "c2", type |-> "PREVOTE"],
    [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
    [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
    [proposal |-> "v1",
      round |-> 0,
      src |-> "f4",
      type |-> "PROPOSAL",
      validRound |-> 0] }
/\ lockedRound = "c1" :> 0 @@ "c2" :> 0
/\ lockedValue = "c1" :> "v0" @@ "c2" :> "v1"
/\ msgsPrecommit
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "c2", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"] }
/\ msgsPrevote
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "c2", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PREVOTE"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PREVOTE"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PREVOTE"] }
/\ msgsPropose
  = 0
      :> { [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 1
      :> { [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 2
      :> { [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
/\ round = "c1" :> 0 @@ "c2" :> 0
/\ step = "c1" :> "PRECOMMIT" @@ "c2" :> "PRECOMMIT"
/\ validRound = "c1" :> 0 @@ "c2" :> 0
/\ validValue = "c1" :> "v0" @@ "c2" :> "v1"

(* Transition 8 to State7 *)

State7 ==
/\ Proposer = 0 :> "f4" @@ 1 :> "c2" @@ 2 :> "c1"
/\ decision = "c1" :> "v1" @@ "c2" :> "None"
/\ evidence
  = { [id |-> "v1", round |-> 0, src |-> "c2", type |-> "PRECOMMIT"],
    [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
    [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
    [proposal |-> "v1",
      round |-> 0,
      src |-> "f4",
      type |-> "PROPOSAL",
      validRound |-> 0] }
/\ lockedRound = "c1" :> 0 @@ "c2" :> 0
/\ lockedValue = "c1" :> "v0" @@ "c2" :> "v1"
/\ msgsPrecommit
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "c2", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"] }
/\ msgsPrevote
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "c2", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PREVOTE"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PREVOTE"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PREVOTE"] }
/\ msgsPropose
  = 0
      :> { [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 1
      :> { [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 2
      :> { [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
/\ round = "c1" :> 0 @@ "c2" :> 0
/\ step = "c1" :> "DECIDED" @@ "c2" :> "PRECOMMIT"
/\ validRound = "c1" :> 0 @@ "c2" :> 0
/\ validValue = "c1" :> "v0" @@ "c2" :> "v1"

(* Transition 9 to State8 *)

State8 ==
/\ Proposer = 0 :> "f4" @@ 1 :> "c2" @@ 2 :> "c1"
/\ decision = "c1" :> "v1" @@ "c2" :> "v0"
/\ evidence
  = { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PRECOMMIT"],
    [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
    [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
    [proposal |-> "v0",
      round |-> 0,
      src |-> "f4",
      type |-> "PROPOSAL",
      validRound |-> 0] }
/\ lockedRound = "c1" :> 0 @@ "c2" :> 0
/\ lockedValue = "c1" :> "v0" @@ "c2" :> "v1"
/\ msgsPrecommit
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "c2", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PRECOMMIT"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PRECOMMIT"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PRECOMMIT"] }
/\ msgsPrevote
  = 0
      :> { [id |-> "v0", round |-> 0, src |-> "c1", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "c2", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 0, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 0, src |-> "f4", type |-> "PREVOTE"] }
    @@ 1
      :> { [id |-> "v0", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 1, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 1, src |-> "f4", type |-> "PREVOTE"] }
    @@ 2
      :> { [id |-> "v0", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v0", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v1", round |-> 2, src |-> "f4", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f3", type |-> "PREVOTE"],
        [id |-> "v2", round |-> 2, src |-> "f4", type |-> "PREVOTE"] }
/\ msgsPropose
  = 0
      :> { [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 0,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 1
      :> { [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 1,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
    @@ 2
      :> { [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v0",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v1",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f3",
          type |-> "PROPOSAL",
          validRound |-> 2],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> -1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 0],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 1],
        [proposal |-> "v2",
          round |-> 2,
          src |-> "f4",
          type |-> "PROPOSAL",
          validRound |-> 2] }
/\ round = "c1" :> 0 @@ "c2" :> 0
/\ step = "c1" :> "DECIDED" @@ "c2" :> "DECIDED"
/\ validRound = "c1" :> 0 @@ "c2" :> 0
/\ validValue = "c1" :> "v0" @@ "c2" :> "v1"

(* The following formula holds true in the last state and violates the invariant *)

InvariantViolation ==
  BMC!Skolem((\E p$20 \in { "c1", "c2" }:
    BMC!Skolem((\E q$2 \in { "c1", "c2" }:
      ~(decision[p$20] = "None")
        /\ ~(decision[q$2] = "None")
        /\ ~(decision[p$20] = decision[q$2])))))

================================================================================
\* Created by Apalache on Sat Mar 28 16:57:25 CET 2020
\* https://github.com/konnov/apalache
